﻿using C1.WPF;
using C1.WPF.PdfViewer;
using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace PdfViewerZoomPercentage
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private C1TextBoxBase pageNumber;
        private C1TextBoxBase find;

        public MainWindow()
        {
            InitializeComponent();
            _pdfViewer.LoadDocument("Resources/Test.pdf");
            _pdfViewer.Loaded += _pdfViewer_Loaded;
        }

        private void _pdfViewer_Loaded(object sender, RoutedEventArgs e)
        {
            _pdfViewer.Focus();
            var pdfViewerToolbar = _pdfViewer.Template.FindName("4_T", _pdfViewer) as C1PdfViewerToolbar;
            pageNumber = pdfViewerToolbar.Template.FindName("PageNumber", pdfViewerToolbar) as C1TextBoxBase;
            find = (pdfViewerToolbar.Template.FindName("4_T", pdfViewerToolbar) as StackPanel).Children[10] as C1TextBoxBase;
        }

        private void ZoomComboBoxLostFocus(object sender, RoutedEventArgs e)
        {
            if ((sender as C1ComboBox).SelectedItem == null && (sender as C1ComboBox).TemplatedParent is C1PdfViewerToolbar)
            {
                if (_pdfViewer.ViewMode != ViewMode.Normal)
                {
                    (sender as C1ComboBox).SelectedItem = _pdfViewer.ViewMode;
                }
                else
                {
                    (sender as C1ComboBox).SelectedItem = _pdfViewer.Zoom;
                }
            }
        }

        private void _pdfViewer_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.KeyboardDevice.Modifiers == System.Windows.Input.ModifierKeys.Control && (e.Key == System.Windows.Input.Key.OemPlus || e.Key == System.Windows.Input.Key.Add))
            {
                _pdfViewer.IncreaseZoomCommand.Execute(_pdfViewer);
            }

            if (e.KeyboardDevice.Modifiers == System.Windows.Input.ModifierKeys.Control && (e.Key == System.Windows.Input.Key.OemMinus || e.Key == System.Windows.Input.Key.Subtract))
            {
                _pdfViewer.IncreaseZoomCommand.Execute(_pdfViewer);
            }

            if (e.KeyboardDevice.Modifiers == System.Windows.Input.ModifierKeys.Alt && e.SystemKey == System.Windows.Input.Key.S)
            {
                find.Focus();
            }

            if (e.KeyboardDevice.Modifiers == (System.Windows.Input.ModifierKeys.Alt | ModifierKeys.Shift) && e.SystemKey == System.Windows.Input.Key.P)
            {
                pageNumber.Focus();
            }
        }
    }
}
